"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createContext = void 0;
const react_1 = __importDefault(require("react"));
function createContext(rootComponentName) {
    const Context = react_1.default.createContext(null);
    function Provider(props) {
        const { children } = props, providerProps = __rest(props, ["children"]);
        // Only re-memoize when prop values change
        const value = react_1.default.useMemo(() => providerProps, 
        // eslint-disable-next-line react-hooks/exhaustive-deps
        Object.values(providerProps));
        return react_1.default.createElement(Context.Provider, { value: value }, children);
    }
    function useContext(consumerName) {
        const context = react_1.default.useContext(Context);
        if (context === null) {
            throw new Error(`\`${consumerName}\` must be used within \`${rootComponentName}\``);
        }
        return context;
    }
    Provider.displayName = rootComponentName + 'Provider';
    return [Provider, useContext];
}
exports.createContext = createContext;
